<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source to the Rust file `/home/keir/.cargo/registry/src/github.com-1ecc6299db9ec823/rand_core-0.5.1/src/os.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>os.rs.html -- source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css"><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script src="../../storage.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="shortcut icon" href="https://www.rust-lang.org/favicon.ico"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../../rand_core/index.html'><div class='logo-container'><img src='https://www.rust-lang.org/logos/rust-logo-128x128-blk.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!"><img src="../../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices"></div></div><script src="../../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><a id="settings-menu" href="../../settings.html"><img src="../../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><pre class="line-numbers"><span id="1"> 1</span>
<span id="2"> 2</span>
<span id="3"> 3</span>
<span id="4"> 4</span>
<span id="5"> 5</span>
<span id="6"> 6</span>
<span id="7"> 7</span>
<span id="8"> 8</span>
<span id="9"> 9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
</pre><div class="example-wrap"><pre class="rust ">
<span class="comment">// Copyright 2019 Developers of the Rand project.</span>
<span class="comment">//</span>
<span class="comment">// Licensed under the Apache License, Version 2.0 &lt;LICENSE-APACHE or</span>
<span class="comment">// https://www.apache.org/licenses/LICENSE-2.0&gt; or the MIT license</span>
<span class="comment">// &lt;LICENSE-MIT or https://opensource.org/licenses/MIT&gt;, at your</span>
<span class="comment">// option. This file may not be copied, modified, or distributed</span>
<span class="comment">// except according to those terms.</span>

<span class="doccomment">//! Interface to the random number generator of the operating system.</span>
<span class="comment">// Note: keep this code in sync with the rand_os crate!</span>

<span class="kw">use</span> <span class="ident">getrandom</span>::<span class="ident">getrandom</span>;
<span class="kw">use</span> <span class="kw">crate</span>::{<span class="ident">CryptoRng</span>, <span class="ident">RngCore</span>, <span class="ident">Error</span>, <span class="ident">impls</span>};

<span class="doccomment">/// A random number generator that retrieves randomness from from the</span>
<span class="doccomment">/// operating system.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This is a zero-sized struct. It can be freely constructed with `OsRng`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The implementation is provided by the [getrandom] crate. Refer to</span>
<span class="doccomment">/// [getrandom] documentation for details.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This struct is only available when specifying the crate feature `getrandom`</span>
<span class="doccomment">/// or `std`. When using the `rand` lib, it is also available as `rand::rngs::OsRng`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Blocking and error handling</span>
<span class="doccomment">///</span>
<span class="doccomment">/// It is possible that when used during early boot the first call to `OsRng`</span>
<span class="doccomment">/// will block until the system&#39;s RNG is initialised. It is also possible</span>
<span class="doccomment">/// (though highly unlikely) for `OsRng` to fail on some platforms, most</span>
<span class="doccomment">/// likely due to system mis-configuration.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// After the first successful call, it is highly unlikely that failures or</span>
<span class="doccomment">/// significant delays will occur (although performance should be expected to</span>
<span class="doccomment">/// be much slower than a user-space PRNG).</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Usage example</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use rand_core::{RngCore, OsRng};</span>
<span class="doccomment">///</span>
<span class="doccomment">/// let mut key = [0u8; 16];</span>
<span class="doccomment">/// OsRng.fill_bytes(&amp;mut key);</span>
<span class="doccomment">/// let random_u64 = OsRng.next_u64();</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [getrandom]: https://crates.io/crates/getrandom</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">Debug</span>, <span class="ident">Default</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">OsRng</span>;

<span class="kw">impl</span> <span class="ident">CryptoRng</span> <span class="kw">for</span> <span class="ident">OsRng</span> {}

<span class="kw">impl</span> <span class="ident">RngCore</span> <span class="kw">for</span> <span class="ident">OsRng</span> {
    <span class="kw">fn</span> <span class="ident">next_u32</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">u32</span> {
        <span class="ident">impls</span>::<span class="ident">next_u32_via_fill</span>(<span class="self">self</span>)
    }

    <span class="kw">fn</span> <span class="ident">next_u64</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">u64</span> {
        <span class="ident">impls</span>::<span class="ident">next_u64_via_fill</span>(<span class="self">self</span>)
    }

    <span class="kw">fn</span> <span class="ident">fill_bytes</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">dest</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">u8</span>]) {
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Err</span>(<span class="ident">e</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">try_fill_bytes</span>(<span class="ident">dest</span>) {
            <span class="macro">panic</span><span class="macro">!</span>(<span class="string">&quot;Error: {}&quot;</span>, <span class="ident">e</span>);
        }
    }

    <span class="kw">fn</span> <span class="ident">try_fill_bytes</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">dest</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">u8</span>]) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident">Error</span><span class="op">&gt;</span> {
        <span class="ident">getrandom</span>(<span class="ident">dest</span>)<span class="question-mark">?</span>;
        <span class="prelude-val">Ok</span>(())
    }
}

<span class="attribute">#[<span class="ident">test</span>]</span>
<span class="kw">fn</span> <span class="ident">test_os_rng</span>() {
    <span class="kw">let</span> <span class="ident">x</span> <span class="op">=</span> <span class="ident">OsRng</span>.<span class="ident">next_u64</span>();
    <span class="kw">let</span> <span class="ident">y</span> <span class="op">=</span> <span class="ident">OsRng</span>.<span class="ident">next_u64</span>();
    <span class="macro">assert</span><span class="macro">!</span>(<span class="ident">x</span> <span class="op">!</span><span class="op">=</span> <span class="number">0</span>);
    <span class="macro">assert</span><span class="macro">!</span>(<span class="ident">x</span> <span class="op">!</span><span class="op">=</span> <span class="ident">y</span>);
}

<span class="attribute">#[<span class="ident">test</span>]</span>
<span class="kw">fn</span> <span class="ident">test_construction</span>() {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">rng</span> <span class="op">=</span> <span class="ident">OsRng</span>::<span class="ident">default</span>();
    <span class="macro">assert</span><span class="macro">!</span>(<span class="ident">rng</span>.<span class="ident">next_u64</span>() <span class="op">!</span><span class="op">=</span> <span class="number">0</span>);
}
</pre></div>
</section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../../";window.currentCrate = "rand_core";</script><script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script><script defer src="../../search-index.js"></script></body></html>